<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.9.1"/>
<title>Flair: Pid.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="logo_hds.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">Flair
   </div>
   <div id="projectbrief">Framework Libre Air</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.9.1 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_pid_8h_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Pid.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_pid_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// %flair:license{</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// This file is part of the Flair framework distributed under the</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">// CECILL-C License, Version 1.0.</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">// %flair:license}</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"></span><span class="preprocessor">#ifndef PID_H</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#define PID_H</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_control_law_8h.html">ControlLaw.h</a>&gt;</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespaceflair.html">flair</a> {</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="keyword">namespace </span>gui {</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="keyword">class </span>LayoutPosition;</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;}</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;}</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="keyword">class </span>Pid_impl;</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespaceflair.html">flair</a> {</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="keyword">namespace </span>filter {</div>
<div class="line"><a name="l00032"></a><span class="lineno"><a class="line" href="classflair_1_1filter_1_1_pid.html">   32</a></span>&#160;<span class="keyword">class </span><a class="code" href="classflair_1_1filter_1_1_pid.html">Pid</a> : <span class="keyword">public</span> <a class="code" href="classflair_1_1filter_1_1_control_law.html">ControlLaw</a> {</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;  <span class="keyword">friend</span> class ::Pid_impl;</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;  <a class="code" href="classflair_1_1filter_1_1_pid.html#a6505c295f5e719f1d85620b44c62d619">Pid</a>(<span class="keyword">const</span> <a class="code" href="classflair_1_1gui_1_1_layout_position.html">gui::LayoutPosition</a> *position, std::string name);</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;  <a class="code" href="classflair_1_1filter_1_1_pid.html#ab8e08d20453ac21096363f591ac365df">~Pid</a>();</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classflair_1_1filter_1_1_pid.html#a41573a79913af95cbb94d30225e913b6">Reset</a>(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;  </div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;  <span class="keywordtype">float</span> <a class="code" href="classflair_1_1filter_1_1_pid.html#a54ef7c5dc588f52954121e22faf50b92">GetIntegral</a>(<span class="keywordtype">void</span>) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classflair_1_1filter_1_1_pid.html#a27c025ae6b9a9a192a234ab74e2e6f8b">SetValues</a>(<span class="keywordtype">float</span> p, <span class="keywordtype">float</span> d);</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classflair_1_1filter_1_1_pid.html#a8128ecc530ff19abae93027d72d4b5ec">UseDefaultPlot</a>(<span class="keyword">const</span> <a class="code" href="classflair_1_1gui_1_1_layout_position.html">gui::LayoutPosition</a> *position);</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;<span class="keyword">private</span>:</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;  <span class="keywordtype">void</span> UpdateFrom(<span class="keyword">const</span> <a class="code" href="classflair_1_1core_1_1io__data.html">core::io_data</a> *data);</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;  Pid_impl *pimpl_;</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;};</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;} <span class="comment">// end namespace filter</span></div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;} <span class="comment">// end namespace flair</span></div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;<span class="preprocessor">#endif // PID_H</span></div>
<div class="ttc" id="classflair_1_1core_1_1io__data_html"><div class="ttname"><a href="classflair_1_1core_1_1io__data.html">flair::core::io_data</a></div><div class="ttdoc">Abstract class for data types. </div><div class="ttdef"><b>Definition:</b> io_data.h:94</div></div>
<div class="ttc" id="classflair_1_1filter_1_1_control_law_html"><div class="ttname"><a href="classflair_1_1filter_1_1_control_law.html">flair::filter::ControlLaw</a></div><div class="ttdoc">Base class for control law input must be created by reimplemented class. output is created by this cl...</div><div class="ttdef"><b>Definition:</b> ControlLaw.h:36</div></div>
<div class="ttc" id="classflair_1_1filter_1_1_pid_html_a6505c295f5e719f1d85620b44c62d619"><div class="ttname"><a href="classflair_1_1filter_1_1_pid.html#a6505c295f5e719f1d85620b44c62d619">flair::filter::Pid::Pid</a></div><div class="ttdeci">Pid(const gui::LayoutPosition *position, std::string name)</div><div class="ttdoc">Constructor. </div></div>
<div class="ttc" id="namespaceflair_html"><div class="ttname"><a href="namespaceflair.html">flair</a></div><div class="ttdoc">namespace of the flair Framework </div><div class="ttdef"><b>Definition:</b> Ahrs.h:19</div></div>
<div class="ttc" id="classflair_1_1filter_1_1_pid_html_a41573a79913af95cbb94d30225e913b6"><div class="ttname"><a href="classflair_1_1filter_1_1_pid.html#a41573a79913af95cbb94d30225e913b6">flair::filter::Pid::Reset</a></div><div class="ttdeci">void Reset(void)</div><div class="ttdoc">Reset integral. </div></div>
<div class="ttc" id="classflair_1_1filter_1_1_pid_html_ab8e08d20453ac21096363f591ac365df"><div class="ttname"><a href="classflair_1_1filter_1_1_pid.html#ab8e08d20453ac21096363f591ac365df">flair::filter::Pid::~Pid</a></div><div class="ttdeci">~Pid()</div><div class="ttdoc">Destructor. </div></div>
<div class="ttc" id="classflair_1_1filter_1_1_pid_html_a8128ecc530ff19abae93027d72d4b5ec"><div class="ttname"><a href="classflair_1_1filter_1_1_pid.html#a8128ecc530ff19abae93027d72d4b5ec">flair::filter::Pid::UseDefaultPlot</a></div><div class="ttdeci">void UseDefaultPlot(const gui::LayoutPosition *position)</div><div class="ttdoc">Use default plot. </div></div>
<div class="ttc" id="_control_law_8h_html"><div class="ttname"><a href="_control_law_8h.html">ControlLaw.h</a></div><div class="ttdoc">Base class for control law. </div></div>
<div class="ttc" id="classflair_1_1filter_1_1_pid_html"><div class="ttname"><a href="classflair_1_1filter_1_1_pid.html">flair::filter::Pid</a></div><div class="ttdoc">Class defining a PID. </div><div class="ttdef"><b>Definition:</b> Pid.h:32</div></div>
<div class="ttc" id="classflair_1_1gui_1_1_layout_position_html"><div class="ttname"><a href="classflair_1_1gui_1_1_layout_position.html">flair::gui::LayoutPosition</a></div><div class="ttdoc">Class to define a position in a layout on the ground station. </div><div class="ttdef"><b>Definition:</b> LayoutPosition.h:28</div></div>
<div class="ttc" id="classflair_1_1filter_1_1_pid_html_a27c025ae6b9a9a192a234ab74e2e6f8b"><div class="ttname"><a href="classflair_1_1filter_1_1_pid.html#a27c025ae6b9a9a192a234ab74e2e6f8b">flair::filter::Pid::SetValues</a></div><div class="ttdeci">void SetValues(float p, float d)</div><div class="ttdoc">Set input values. </div></div>
<div class="ttc" id="classflair_1_1filter_1_1_pid_html_a54ef7c5dc588f52954121e22faf50b92"><div class="ttname"><a href="classflair_1_1filter_1_1_pid.html#a54ef7c5dc588f52954121e22faf50b92">flair::filter::Pid::GetIntegral</a></div><div class="ttdeci">float GetIntegral(void) const </div><div class="ttdoc">Get intergral part. </div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_33c2ee9b1665499374b4225c427cf176.html">igep</a></li><li class="navelem"><a class="el" href="dir_f1fe274389177bd7e17de7949c4ffada.html">flair-src</a></li><li class="navelem"><a class="el" href="dir_3ef62148cf94871b4b6ee5d6e3a989c1.html">lib</a></li><li class="navelem"><a class="el" href="dir_c640b400eb634d478af9606dd6c9f1e6.html">FlairFilter</a></li><li class="navelem"><a class="el" href="dir_9f4b49da50e680b0f2ceec11232e4cfd.html">src</a></li><li class="navelem"><a class="el" href="_pid_8h.html">Pid.h</a></li>
    <li class="footer">Generated on Thu Jan 31 2019 12:34:23 for Flair by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.9.1 </li>
  </ul>
</div>
</body>
</html>
